/* eslint no-unused-vars:0 */
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Audio = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Image = require('./Image');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _raf = require('raf');

var _raf2 = _interopRequireDefault(_raf);

var _Audio = {
  "audio-flex-container": "Audio__audio-flex-container___3z6Kk",
  "audio-flex-coverphoto": "Audio__audio-flex-coverphoto___2iX-c",
  "audio-flex-info": "Audio__audio-flex-info___-px5B",
  "without-coverphoto": "Audio__without-coverphoto___1UMKa",
  "flex-item": "Audio__flex-item___1lQGc",
  "audio-slider": "Audio__audio-slider___1yTq6"
};

var _Audio2 = _interopRequireDefault(_Audio);

var _CircleProgressButton = require('./CircleProgressButton');

var _CircleProgressButton2 = _interopRequireDefault(_CircleProgressButton);

var _reactHowler = require('react-howler');

var _reactHowler2 = _interopRequireDefault(_reactHowler);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _rcSlider = require('rc-slider');

var _rcSlider2 = _interopRequireDefault(_rcSlider);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // requestAnimationFrame polyfill
// eslint-disable-line


if (process.env.BROWSER) {}

var Audio = function (_React$Component) {
  _inherits(Audio, _React$Component);

  function Audio(props) {
    _classCallCheck(this, Audio);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(Audio).call(this, props));

    _this.state = {
      duration: 100,
      loaded: false,
      isPlaying: false,
      seek: 0
    };
    _this.handleToggle = _this._handleToggle.bind(_this);
    _this.handleOnLoad = _this._handleOnLoad.bind(_this);
    _this.handleOnEnd = _this._handleOnEnd.bind(_this);
    _this.handleOnPlay = _this._handleOnPlay.bind(_this);
    _this.renderSeekPos = _this._renderSeekPos.bind(_this);
    _this.onSeekChange = _this._onSeekChange.bind(_this);
    return _this;
  }

  _createClass(Audio, [{
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.clearRAF();
    }
  }, {
    key: '_getMinSecStr',
    value: function _getMinSecStr(time) {
      time = Math.round(time);
      var minutes = Math.floor(time / 60);
      var seconds = time - minutes * 60;
      seconds = seconds < 10 ? 0 + seconds.toString() : seconds.toString();
      return minutes + ':' + seconds;
    }
  }, {
    key: '_handleToggle',
    value: function _handleToggle(e) {
      e.stopPropagation();
      this.setState({
        isPlaying: !this.state.isPlaying
      });
    }
  }, {
    key: '_handleOnLoad',
    value: function _handleOnLoad() {
      this.setState({
        loaded: true,
        duration: this.player.duration()
      });
    }
  }, {
    key: '_handleOnPlay',
    value: function _handleOnPlay() {
      this.setState({
        isPlaying: true
      });
      this.renderSeekPos();
    }
  }, {
    key: '_handleOnEnd',
    value: function _handleOnEnd() {
      this.setState({
        isPlaying: false
      });
      this.clearRAF();
    }
  }, {
    key: '_handleSelect',
    value: function _handleSelect(e) {
      e.stopPropagation();
      this.props.onSelect(e);
    }
  }, {
    key: '_renderSeekPos',
    value: function _renderSeekPos() {
      this.setState({
        seek: this.player.seek()
      });
      if (this.state.isPlaying) {
        this._raf = (0, _raf2.default)(this.renderSeekPos);
      }
    }
  }, {
    key: '_onSeekChange',
    value: function _onSeekChange(seek) {
      var _this2 = this;

      this.setState({
        seek: seek
      }, function () {
        _this2.player.seek(seek);
      });
    }
  }, {
    key: 'clearRAF',
    value: function clearRAF() {
      _raf2.default.cancel(this._raf);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var content = this.props.content;
      var _state = this.state;
      var duration = _state.duration;
      var isPlaying = _state.isPlaying;
      var seek = _state.seek;

      var _$get = _lodash2.default.get(content, 0, {});

      var url = _$get.url;
      var coverPhoto = _$get.coverPhoto;
      var title = _$get.title;
      var description = _$get.description;

      var image = _lodash2.default.get(coverPhoto, ['resizedTargets'], null);
      var coverPhotoStyle = image ? '' : _Audio2.default['without-coverphoto'];

      return _react2.default.createElement(
        'div',
        { className: _Audio2.default['audio-flex-container'] },
        image ? _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(_Audio2.default['audio-flex-coverphoto'], 'col-md-12', 'hidden-xs') },
          _react2.default.createElement(_Image.Image, {
            content: [image]
          })
        ) : null,
        _react2.default.createElement(
          'div',
          { className: (0, _classnames2.default)(_Audio2.default['audio-flex-info'], coverPhotoStyle) },
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Audio2.default['flex-item'], coverPhotoStyle) },
            _react2.default.createElement(_CircleProgressButton2.default, {
              duration: duration,
              isPlaying: isPlaying,
              seek: seek,
              onToggle: this.handleToggle
            }),
            _react2.default.createElement(
              'div',
              { className: _Audio2.default['audio-slider'] },
              _react2.default.createElement(
                'span',
                null,
                this._getMinSecStr(seek),
                ' / ',
                this._getMinSecStr(duration)
              ),
              _react2.default.createElement(_rcSlider2.default, {
                tipFormatter: null,
                onChange: this.onSeekChange,
                value: seek,
                max: duration
              })
            )
          ),
          image ? _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Audio2.default['flex-item'], 'col-xs-12', 'visible-xs') },
            _react2.default.createElement(_Image.Image, {
              content: [image]
            })
          ) : null,
          _react2.default.createElement(
            'div',
            { className: (0, _classnames2.default)(_Audio2.default['flex-item'], coverPhotoStyle) },
            _react2.default.createElement(
              'h4',
              null,
              title
            ),
            _react2.default.createElement('div', { dangerouslySetInnerHTML: { __html: description } })
          )
        ),
        _react2.default.createElement(_reactHowler2.default, {
          src: url,
          playing: isPlaying,
          onLoad: this.handleOnLoad,
          onPlay: this.handleOnPlay,
          onEnd: this.handleOnEnd,
          ref: function ref(_ref) {
            return _this3.player = _ref;
          }
        })
      );
    }
  }]);

  return Audio;
}(_react2.default.Component);

Audio.propTypes = {
  content: _react2.default.PropTypes.array,
  customeStyles: _react2.default.PropTypes.array
};

Audio.defaultProps = {
  content: [],
  customeStyles: []
};

exports.Audio = Audio;