'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getArticleComponent;

var _index = require('./index');

var ArticleComps = _interopRequireWildcard(_index);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function getArticleComponent() {
  var type = arguments.length <= 0 || arguments[0] === undefined ? 'unstyled' : arguments[0];

  switch (type) {
    case 'audio':
      return ArticleComps.Audio;
    case 'code':
      return null;
    case 'embeddedCode':
      return ArticleComps.AlignedEmbedded;
    case 'image':
      return ArticleComps.AlignedImage;
    case 'imageDiff':
      return ArticleComps.AlignedImageDiff;
    case 'infobox':
      return ArticleComps.AlignedInfoBox;
    case 'ordered-list':
    case 'unordered-list':
      return null;
    case 'blockquote':
      return ArticleComps.AlignedBlockQuote;
    case 'unstyled':
      return ArticleComps.Paragraph;
    case 'slideshow':
      return ArticleComps.Slideshow;
  }
}